#ifndef __ALG_DEF__
#define __ALG_DEF__


#ifndef VOID
typedef void VOID;
#endif

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#ifndef __WinDefs__

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef UCHAR
typedef unsigned char UCHAR;
#endif

#ifndef PUCHAR
typedef unsigned char *PUCHAR;
#endif

#ifndef WORD
typedef unsigned short WORD;
#endif

#ifndef USHORT
typedef unsigned short USHORT;
#endif

#ifndef _WINDEF_
#ifndef DWORD
#ifdef _WIN32
typedef unsigned long DWORD;
#else
typedef unsigned int DWORD;
#endif
#endif

#ifndef PDWORD
typedef DWORD *PDWORD;
#endif
#endif

#ifndef UINT
typedef unsigned int UINT;
#endif

#ifndef PUINT
typedef unsigned int *PUINT;
#endif

#ifndef BOOL
#ifndef __APPLE__
typedef int BOOL;
#else
typedef signed char BOOL;
#endif
#endif

#endif


#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE  1
#endif

#endif //__ALG_DEF__
